
# ------------------------------------------------------------------------
#	Allgemeine Regeln fuer alle Makefiles (diese Datei nicht aendern!)
#	26.2.96 erik, kodi, moritz
# ------------------------------------------------------------------------

ALL_CFLAGS = $(CFLAGS) $(CONF_CFLAGS)

.SUFFIXES: .cc

# ------------------------------------------------------------------------

.y.c:
	@echo "$LMAKING $<"
	$(YACC) -d $(YFLAGS) $<
	$(RM) $*.h
	$(MV) y.tab.h $*.h
	$(RM) $*.c
	$(MV) y.tab.c $*.c

.y.o:
	@echo "$LMAKING $<"
	$(YACC) -d $(YFLAGS) $<
	$(RM) $*.h
	$(MV) y.tab.h $*.h
	$(RM) $*.c
	$(MV) y.tab.c $*.c
	$(CC) $(ALL_CFLAGS) -c $*.c -o $@
	$(RM) $*.c

.l.c:
	@echo "$LMAKING $<"
	$(LEX) $(LFLAGS) -t $< > $*.c

.l.o:
	@echo "$LMAKING $<"
	$(LEX) $(LFLAGS) -t $< > $*.c
	$(CC) $(ALL_CFLAGS) -c $*.c -o $@
	$(RM) $*.c

.c.o:
	@echo "$LMAKING $<"
	$(CC) $(ALL_CFLAGS) -c $< -o $@
		
.lpp.cc:
	@echo "$LMAKING $<"
	$(LEX) -+ $(LFLAGS) -t $< > $*.cc

.lpp.o:
	@echo "$LMAKING $<"
	$(LEX) -+ $(LFLAGS) -t $< > $*.cc
	$(CC) $(ALL_CFLAGS) -c $*.cc -o $@
	$(RM) $*.cc

.cc.o:
	@echo "$LMAKING $<"
	$(CC) $(ALL_CFLAGS) -c $< -o $@
	

# ------------------------------------------------------------------------

help:	;@egrep '^[^:;=.]*::?[ 	]*#' [mM]akefile

subproj:
	@(for subproj in $(LISTOFPROJECTS) ; do \
		echo "$LMAKING $(TARGET) IN $$subproj"; \
		$(PUSHD) $$subproj; \
		$(MAKE) $(TARGET) "PROJ_NAME = $$subproj"\
			"CONF_CFLAGS = $(CONF_CFLAGS)"; \
		$(POPD); \
		echo "$LFINISHED MAKING $(TARGET) IN $$subproj"; \
		done )
 
 
 
