

#include "Agent.h"
#include "AgentList.h"

#define NO_AGENT	0

static int DL = 100;

/* ----------------------------------------------------------------- */

IterStateType 
Agent_InitFriendIteration (AgentType * PtrAgent)
{
  if (PtrAgent->PtrFriendList)
    return AgentList_InitIteration (PtrAgent->PtrFriendList);
  else
    return NULL;
}

AgentIdType 
Agent_GetNextFriend (AgentType * PtrAgent, IterStateType * PtrState)
{
  if (PtrState && *PtrState)
    return AgentList_Next (PtrAgent->PtrFriendList, PtrState);
  else
    return 0;
}

bool 
Agent_AddFriend (AgentType * PtrAgent, AgentIdType Friend)
{
  if (PtrAgent->NumberOfFriends >= PtrAgent->MaxFriends)
    Agent_LooseFriend (PtrAgent);

  if (!PtrAgent->PtrFriendList)
    {
      PtrAgent->PtrFriendList = AgentList_CreateList ();
      PtrAgent->NumberOfFriends = 0;
    }
  AgentList_Append (PtrAgent->PtrFriendList, Friend);
  PtrAgent->NumberOfFriends++;
  return 1;
}

AgentIdType 
Agent_LooseFriend (AgentType * PtrAgent)
{
  AgentIdType Friend;

  if (PtrAgent->NumberOfFriends > 0)
    {
      Friend = PtrAgent->PtrFriendList->PtrHead->AgentId;
      AgentList_RemoveFront (PtrAgent->PtrFriendList);
      PtrAgent->NumberOfFriends--;
      return Friend;
    }
  else
    return NO_AGENT;
}

bool 
Agent_IsFriendOf (AgentType * PtrAgent, AgentIdType Friend)
{
  if (PtrAgent->PtrFriendList)
    return AgentList_IsMember (PtrAgent->PtrFriendList, Friend);
  else
    return 0;
}

bool 
Agent_MeetFriend (AgentType * PtrAgent, AgentIdType Friend)
{
  if (Agent_IsFriendOf (PtrAgent, Friend))
    {
      AgentList_Remove (PtrAgent->PtrFriendList, Friend);
      AgentList_Append (PtrAgent->PtrFriendList, Friend);
      return 1;
    }
  else
    return 0;
}

bool 
Agent_MakeFriend (AgentType * PtrAgent, AgentIdType Friend)
{
  if (Agent_IsFriendOf (PtrAgent, Friend))
    return Agent_MeetFriend (PtrAgent, Friend);
  else
    return Agent_AddFriend (PtrAgent, Friend);
}
