

#ifndef __AGENTLIST_H
#define __AGENTLIST_H

#include "AgentTypeDefs.h"

/*typedef void                          AgentIdNodeType;
   typedef void                         AgentIdListType; */
typedef struct _AgentIdNodeType
  {
    struct _AgentIdNodeType *PtrPrev;
    struct _AgentIdNodeType *PtrNext;
    AgentIdType AgentId;
  }
AgentIdNodeType;

typedef struct _AgentIdListType
  {
    AgentIdNodeType *PtrHead;
    unsigned int Length;
  }
AgentIdListType;


typedef AgentIdListType FriendListType;
typedef AgentIdNodeType *IterStateType;

AgentIdListType *AgentList_CreateList ();
AgentIdListType *AgentList_CopyList (AgentIdListType * PtrDest,
				     const AgentIdListType * PtrSrc);
void AgentList_DestroyList (AgentIdListType * PtrList);
void AgentList_EmptyList (AgentIdListType * PtrList);

bool AgentList_IsEmpty (const AgentIdListType * PtrList);
bool AgentList_IsAtom (const AgentIdListType * PtrList);
int AgentList_Count (const AgentIdListType * PtrList);
inline int AgentList_Length (const AgentIdListType * PtrList);

inline AgentIdType AgentList_IdAt (const AgentIdListType * PtrList, int index);
int AgentList_IndexOfAgentId (const AgentIdListType * PtrList,
			      AgentIdType AgentId);
bool AgentList_IsMember (const AgentIdListType * PtrList,
			 AgentIdType AgentId);

void AgentList_Prepend (AgentIdListType * PtrList,
			AgentIdType AgentId);
void AgentList_Append (AgentIdListType * PtrList,
		       AgentIdType AgentId);

void AgentList_Remove (AgentIdListType * PtrList,
		       AgentIdType AgentId);
AgentIdType AgentList_RemoveFront (AgentIdListType * PtrList);
AgentIdType AgentList_RemoveRear (AgentIdListType * PtrList);

IterStateType AgentList_InitIteration (const AgentIdListType * PtrList);
AgentIdType AgentList_Next (const AgentIdListType * PtrList,
			    IterStateType * PtrState);

#endif
