



#ifndef __AGENT_SETS_H
#define __AGENT_SETS_H

#include "Agent.h"
#include "../dictionary/Dictionary.h"

/*typedef void  AgentSet; */
typedef struct _AgentSet
  {
    DictType *Map;
    AgentIdListType *List;

    AgentIdType CurrentId;
  }
AgentSet;

inline AgentType *AgentSets_GetAgent (const AgentSet * Set,
				      AgentIdType AgentId);

AgentIdType AgentSets_InsertAgent (AgentSet * Set,
			   AgentIdType AgentId, const AgentType * PtrAgent);
AgentType *AgentSets_RemoveAgent (AgentSet * Set, AgentIdType AgentId);

inline unsigned AgentSets_GetCount (const AgentSet * Set);

inline IterStateType AgentSets_InitAgentIteration (const AgentSet * Set);
inline AgentIdType AgentSets_GetNextAgent (const AgentSet * Set,
					   IterStateType * PtrState);

void AgentSets_ForEach (AgentSet * Set,
			void (*todo) (AgentSet *, AgentIdType, void *),
			void *data);
void AgentSets_ForEachAgent (AgentSet * Set,
			     void (*todo) (AgentType *, void *), void *data);

AgentSet *AgentSets_CreateAgentSet ();
void AgentSets_DestroyAgentSet (AgentSet * Set);

#endif
