


#include "AgentList.h"

void 
print_list (AgentIdListType * list)
{
  AgentIdNode *node;

  printf ("List: %d ----------------------------\n", AgentList_Count (list));
  for (node = AgentList_Head (list); node; node = AgentList_Succ (list, node))
    {
      int i = AgentList_IndexOf (list, node);
      printf ("(%d %p) ", i, AgentList_NodeAt (list, i));
      printf ("%p %d %p\n", node->PtrPrev, node->AgentId, node->PtrNext);
    }
}

int 
main ()
{
  char c;
  int n;
  AgentIdListType *list = AgentList_CreateList ();

  do
    {
      scanf ("%c %d", &c, &n);
      switch (c)
	{
	case 'h':
	  AgentList_RemoveFront (list);
	  break;
	case 't':
	  AgentList_RemoveRear (list);
	  break;
	case 'd':
	  AgentList_Remove (list, n);
	  break;
	case 'a':
	case 'i':
	  if (!AgentList_IsMember (list, n))
	    AgentList_Append (list, n);
	  break;
	case 'p':
	  if (!AgentList_IsMember (list, n))
	    AgentList_Prepend (list, n);
	  break;
	case 'q':
	  AgentList_DestroyList (list);
	  exit (0);
	}
      print_list (list);
    }
  while (1);
}
