%option lex-compat

%Start  COM

%{

#include "LoaderParser_yacc.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef FALSE
#define FALSE (1 == 0)
#define TRUE  (1 == 1)
#endif

int Standard;

extern void ReturnBufferToFile(FILE*, YY_BUFFER_STATE);
%}
string		[a-zA-Z0-9_]+
datum		[0-9][0-9]\.[0-9][0-9]\.[1-2][0-9][0-9][0-9]
uhrzeit		[0-2][0-9]\:[0-6][0-9]\:[0-6][0-9]
fliesskomma	[+-]?[0-9]*\.[0-9]*
ganzzahl	[+-]?[0-9]+

%%
<COM>"END_COMMENT"  BEGIN 0;
<COM>.*         |
<COM>\n         ;

"COMMENT"       BEGIN COM;

\#.*\n          | 
\n		|
\t              /* */
		;
"HEADER"        { return (HEADER); }
"END_HEADER"    { return (END_HEADER); }
"MAP"           { return (MAP); }
"END_MAP"       { return (END_MAP); }
"AGENTS"        {
                  ReturnBufferToFile   (LOADERin, YY_CURRENT_BUFFER); 
                  AgentSet_ParseSection(LOADERin);
                  YY_FLUSH_BUFFER; 
                }

{fliesskomma}   {
                  sscanf(yytext, "%f", &LOADERlval.typflt);
		  return(FLT);
		}
{ganzzahl}	{
                  LOADERlval.typint=atoi(yytext);	
		  return(INT);
                }
{string}	{	
                  strncpy(LOADERlval.typstr, yytext, 255);
		  LOADERlval.typstr[255]='\0';          
		  return (STR);
                }
.		;
%%


int LOADERwrap ()
{
  return (1);
}

void main (int argc, char **argv)
{
  int arg_count = argc, c;
  
  if (argc < 2)
    {
      printf ("usage: %s [-v] [-s] <file>\n", argv[0]);
      printf ("       -s     read data from standard input\n");
      printf ("       <file> name of file to parse\n");
      exit (1); 
    }
  else
    {
      for (c = 1; c < arg_count; c++)
	{
	  if (!strcmp (argv[c], "-s")) 
	    { 
	      printf ("read from standard input\n"); 
	      Standard = TRUE; 
	    }
	}
      
      if (!Standard) 
	{
	  printf ("%s\n", argv[arg_count - 1]);
	  	  
	  Loader_LoadFile (argv[arg_count - 1]);
	}
      else 
	Loader_LoadFile (stdin);
    }
}





