#ifndef DUMP_H
#define DUMP_H

/*-module-*****************************************************************
 *
 * Modul     : Dump (Funktionsmodul-Definitionen)
 *
 * Beschreib.: Diese Header-Datei dient zur Bereitstellung der
 *             Exportschnittstelle der gleichnamigen C-Datei.
 *             Sie muss in den Modulen includet werden, in denen
 *             die beschriebenen Ressourcen importiert werden sollen.
 *
 * Autor     : <autor>
 *
 * Datum     : <datum>
 *
 * Aender.   :
 *
 *   geaendert am              von             Bemerkungen
 *
 *--**********************************************************************/

#include "../misc/TypeDefs.h"

/*-import-*/

bool Dump_ParseSection (FILE * Stream);

void Dump_EndSimulation ();

void Dump_CloseFiles ();

bool Dump_SetParameterValue (string ParameterName,
			     string Value);

void Dump_InitTimeStep (CountType Timestep);

void Dump_ConcludeTimeStep (CountType TimeStep);

bool Dump_WantDumpHeader ();

bool Dump_WantDumpDump ();

bool Dump_WantDumpParameters ();

bool Dump_WantDumpAgentsSection ();

bool Dump_WantDumpAgentAttributes ();

bool Dump_WantDumpAgentStatus ();

bool Dump_WantDumpAgentProgram ();

bool Dump_WantDumpActions ();

bool Dump_WantDumpMapComplete ();

bool Dump_WantDumpMapIncremental ();

bool Dump_WantDumpMapAgents ();

bool Dump_WantDumpMapFood ();

bool Dump_WantDumpMapCompleteXPM ();

bool Dump_WantDumpMapAgentsXPM ();

bool Dump_WantDumpMapFoodXPM ();


bool Dump_WantDumpStatistics ();

bool Dump_WantDumpBirthAndDeath ();

bool Dump_DumpHeader ();

bool Dump_DumpDump ();

bool Dump_DumpParameters ();

bool Dump_DumpAgent (string Buffer);

bool Dump_DumpAgentAttributes (string Buffer);

bool Dump_DumpAgentStatus (string Buffer);

bool Dump_DumpAgentProgram (string Buffer);

bool Dump_DumpActions (string Buffer);

bool Dump_DumpMapComplete (string Buffer);

bool Dump_DumpMapIncremental (string Buffer);

bool Dump_DumpMapAgents (string Buffer);

bool Dump_DumpMapFood (string Buffer);

bool Dump_DumpMapCompleteXPM (string Buffer);

bool Dump_DumpMapAgentsXPM (string Buffer);

bool Dump_DumpMapFoodXPM (string Buffer);


bool Dump_DumpStatistics (string Buffer);

bool Dump_DumpBirthAndDeath (string Buffer);

/*--*/


#endif
