
#include "../io/IO.h"
#include "../misc/DynaString.h"
#include <sys/param.h>

#ifndef FALSE
#define FALSE (1 == 0)
#endif
#ifndef TRUE
#define TRUE  (1 == 1)
#endif

#define DISPLAY_UNSET		-2
#define DISPLAY_ONCE		-1
#define DISPLAY_NEVER		0
#define DISPLAY_EVERY(n)	(n)

#define DISPLAY_PARAMETERS	20
extern char *DumpParameter[DISPLAY_PARAMETERS];

typedef struct _DumpChannel
  {
    struct _DumpChannel *next;

    char name[MAXPATHLEN + 1];
    FILE *stream;
    IO_ChannelDomainType type;
    char mode[2];
    int flush_immediately;

    DynaStringType *header;
    int display[DISPLAY_PARAMETERS];

    FILE *filePosStream;
  }
DumpChannel;

DumpChannel *Dump_CreateChannel (char *Name, IO_ChannelDomainType Type, char *Mode, int Flush);
DumpChannel *Dump_CloseChannel (char *Name);
DumpChannel *Dump_ReopenChannel (char *Name, char *Mode);

void Dump_SetChannelHeader (DumpChannel * Channel, DynaStringType * Header);
void Dump_DestroyChannels ();
DumpChannel *Dump_FindChannel (char *Name);


bool Dump_SetParameterValueForChannel (DumpChannel * Channel,
				       string Name, string Value);

bool Dump_ChannelWantDump (unsigned Section, DumpChannel * channel);
void Dump_DumpSection ();
