#ifndef INTERPRETER_H
#define INTERPRETER_H

/*-module-*****************************************************************
 *
 * Modul     : Interpreter (Funktionsmodul-Definitionen)
 *
 * Beschreib.: Diese Header-Datei dient zur Bereitstellung der
 *             Exportschnittstelle der gleichnamigen C-Datei.
 *             Sie muss in den Modulen includet werden, in denen
 *             die beschriebenen Ressourcen importiert werden sollen.
 *
 * Autor     : erik
 *
 * Datum     : 22.1.96
 *
 * Aender.   :
 *
 *   geaendert am              von             Bemerkungen
 *
 *--**********************************************************************/

bool Interpreter_SetParameterValue (string key, string value);

bool Interpreter_ParseSection (FILE * Stream);

void Interpreter_InitTimestep (CountType Timestep);

void Interpreter_ConcludeTimestep (CountType Timestep);

void Interpreter_EvalAgent (AgentIdType AgentId);

bool Interpreter_Eval (AgentIdType AgentId, NodePtrType Node);

ProgramType *Interpreter_ParseProgram (FILE * Stream);

string Interpreter_UnparseProgram (ProgramType * Program);

void Interpreter_PrintNodes (FILE * fp, NodePtrType RootNode);

ProgramType *Interpreter_CreateRandomProgram ();


#define IRFM_LEAF 2
#define IRFM_INNER 1

CommandType Interpreter_RandomCommand (int what);



#endif
