
#ifndef INTERPRETER_PRIVATE_H
#define INTERPRETER_PRIVATE_H

#include "../misc/DynaString.h"

typedef struct ArgListType
  {
    int argc;
    NodePtrType argv[FUNC_MAX_ARITY];
  }
ArgListType;

extern DynaStringType *ActionDumpBuffer;

extern int Interpreter_LineNo;

int Interpreter_lex (void);
void Interpreter_error (string msgfmt,...);
int Interpreter_wrap ();

CommandType Interpreter_FunctionNamed (const string Name);
const string Interpreter_NameOfFunction (CommandType Func);
int Interpreter_ArityOfFunction (CommandType Func);
void Interpreter_UnparseProgramInto (ProgramType * Program,
				     DynaStringType * Buffer);
NodePtrType Interpreter_MakeNode (const string Name, const ArgListType * P);

#endif
