


#ifndef IO_H
#define IO_H

/*-module-*****************************************************************
 *
 * Modul     : IO (Funktionsmodul-Definitionen)
 *
 * Beschreib.: Diese Header-Datei dient zur Bereitstellung der
 *             Exportschnittstelle der gleichnamigen C-Datei.
 *             Sie muss in den Modulen includet werden, in denen
 *             die beschriebenen Ressourcen importiert werden sollen.
 *
 * Autor     : erik
 *
 * Datum     : 29.1.1996
 *
 * Aender.   :
 *
 *   geaendert am              von             Bemerkungen
 *
 *--**********************************************************************/

#include "../misc/TypeDefs.h"

typedef enum
  {
    IO_SocketChannel,
    IO_FileChannel,
    IO_PipeChannel,		/* this is a named pipe */
    IO_CommandChannel		/* this is a unnamed pipe to a command 
				   * with popen(Name)
				 */
  }
IO_ChannelDomainType;

#define PHILIA_PORT 	3325

bool IO_MakePort (void);
void IO_InitTimestep (CountType TimeStep);
void IO_ConcludeTimestep (CountType TimeStep);
void IO_WaitForClient (void);
FILE *IO_OpenChannel (IO_ChannelDomainType Domain, const string Name,
		      const string Mode);
bool IO_CloseChannel (IO_ChannelDomainType Domain, const string Name);

#endif
