#ifndef DYNASTRING_H
#define DYNASTRING_H

/*-module-*****************************************************************
 *
 * Modul     : DynaString (Funktionsmodul-Definitionen)
 *
 * Beschreib.: Diese Header-Datei dient zur Bereitstellung der
 *             Exportschnittstelle der gleichnamigen C-Datei.
 *             Sie muss in den Modulen includet werden, in denen
 *             die beschriebenen Ressourcen importiert werden sollen.
 *
 * Autor     : erik
 *
 * Datum     : 5.2.96
 *
 * Aender.   :
 *
 *   geaendert am              von             Bemerkungen
 *
 *--**********************************************************************/

typedef void DynaStringType;	/* Typ ist privat */

DynaStringType *DynaString_Alloc (int InitialSize);
void DynaString_Append (DynaStringType * DString, const string CString);
void DynaString_AppendFormat (DynaStringType * DString, int MaxLen, const string fmt,...);
void DynaString_AppendInt (DynaStringType * DString, int Value);
void DynaString_AppendFloat (DynaStringType * DString, float Value);
string DynaString_CStringAndFree (DynaStringType * DString);
string DynaString_CString (DynaStringType * DString);
void DynaString_Free (DynaStringType * DString);
int DynaString_Length (DynaStringType * DString);
void DynaString_Reset (DynaStringType * DString);

#endif
