
#include <stdlib.h>
#include "Messages.h"

#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif

inline void *
CheckMemory (void *ptr)
{
  if (!ptr)
    Error ("Memory allocation failure!\n");
  return ptr;
}

inline void *
Allocate (size_t size)
{
  return CheckMemory (malloc (size));
}

inline void *
Callocate (size_t numElems, size_t byteSize)
{
  return CheckMemory (calloc (numElems, byteSize));
}

inline void *
Reallocate (void *oldptr, size_t newsize)
{
  if (oldptr)
    return CheckMemory (realloc (oldptr, newsize));
  else
    return Allocate (newsize);
}

inline void *
Free (void *ptr)
{
  if (ptr)
    free (ptr);
  return NULL;
}

inline void *
CopyMemory (void *dest, const void *source, size_t numBytes)
{
  memcpy (dest, source, numBytes);
  return dest;
}
