#ifndef __MESSAGES_H
#define __MESSAGES_H

#include "TypeDefs.h"

#define DEBUG_MODULE_AGENT			0x00000001
#define DEBUG_MODULE_CONTROL		(DEBUG_MODULE_AGENT << 1)
#define DEBUG_MODULE_DICT			(DEBUG_MODULE_CONTROL << 1)
#define DEBUG_MODULE_DUMP			(DEBUG_MODULE_DICT << 1)
#define DEBUG_MODULE_INTERPRET		(DEBUG_MODULE_DUMP << 1)
#define DEBUG_MODULE_IO				(DEBUG_MODULE_INTERPRET << 1)
#define DEBUG_MODULE_LOADER			(DEBUG_MODULE_IO << 1)
#define DEBUG_MODULE_MISC			(DEBUG_MODULE_LOADER << 1)
#define DEBUG_MODULE_PROGRAM		(DEBUG_MODULE_MISC << 1)
#define DEBUG_MODULE_WORLD			(DEBUG_MODULE_PROGRAM << 1)	/* 0x00000200 */
#define DEBUG_MODULES				0x0000FFFF

#define DEBUG_ACTION_INIT			0x00010000
#define DEBUG_ACTION_PARSE			(DEBUG_ACTION_INIT << 1)
#define DEBUG_ACTION_LEX			(DEBUG_ACTION_PARSE << 1)
#define DEBUG_ACTION_EXE			(DEBUG_ACTION_LEX << 1)
#define DEBUG_ACTION_DUMP			(DEBUG_ACTION_EXE << 1)		/* 0x00100000 */
#define DEBUG_ACTION				(DEBUG_ACTION_INIT | DEBUG_ACTION_PARSE | DEBUG_ACTION_LEX | DEBUG_ACTION_EXE | DEBUG_ACTION_DUMP)	/* 0x001F0000 */

#define DEBUG_DETAIL_LOW			0x0001
#define DEBUG_DETAIL_MEDIUM			0x0002
#define DEBUG_DETAIL_HIGH			0x0004
#define DEBUG_DETAIL_ALL			0x0008

#define DEBUG_AGENT_INIT			(DEBUG_MODULE_AGENT | DEBUG_ACTION_INIT)
#define DEBUG_AGENT_PARSE			(DEBUG_MODULE_AGENT | DEBUG_ACTION_PARSE)
#define DEBUG_AGENT_LEX				(DEBUG_MODULE_AGENT | DEBUG_ACTION_LEX)
#define DEBUG_AGENT_EXE				(DEBUG_MODULE_AGENT | DEBUG_ACTION_EXE)
#define DEBUG_AGENT_DUMP			(DEBUG_MODULE_AGENT | DEBUG_ACTION_DUMP)
#define DEBUG_CONTROL_PARSE			(DEBUG_MODULE_CONTROL | DEBUG_ACTION_PARSE)
#define DEBUG_CONTROL_LEX			(DEBUG_MODULE_CONTROL | DEBUG_ACTION_LEX)
#define DEBUG_CONTROL_EXE			(DEBUG_MODULE_CONTROL|DEBUG_ACTION_EXE)
#define DEBUG_CONTROL_DUMP			(DEBUG_MODULE_CONTROL | DEBUG_ACTION_DUMP)
#define DEBUG_DICT_PARSE			(DEBUG_MODULE_DICT | DEBUG_ACTION_PARSE)
#define DEBUG_DICT_LEX				(DEBUG_MODULE_DICT | DEBUG_ACTION_LEX)
#define DEBUG_DICT_EXE				(DEBUG_MODULE_DICT | DEBUG_ACTION_EXE)
#define DEBUG_DICT_DUMP				(DEBUG_MODULE_DICT | DEBUG_ACTION_DUMP)
#define DEBUG_DUMP_PARSE			(DEBUG_MODULE_DUMP | DEBUG_ACTION_PARSE)
#define DEBUG_DUMP_LEX				(DEBUG_MODULE_DUMP | DEBUG_ACTION_LEX)
#define DEBUG_DUMP_EXE				(DEBUG_MODULE_DUMP | DEBUG_ACTION_EXE)
#define DEBUG_DUMP_DUMP				(DEBUG_MODULE_DUMP | DEBUG_ACTION_DUMP)
#define DEBUG_INTERPRET_INIT		(DEBUG_MODULE_INTERPRET|DEBUG_ACTION_INIT)
#define DEBUG_INTERPRET_PARSE		(DEBUG_MODULE_INTERPRET|DEBUG_ACTION_PARSE)
#define DEBUG_INTERPRET_LEX			(DEBUG_MODULE_INTERPRET | DEBUG_ACTION_LEX)
#define DEBUG_INTERPRET_EXE			(DEBUG_MODULE_INTERPRET|DEBUG_ACTION_EXE)
#define DEBUG_INTERPRET_DUMP		(DEBUG_MODULE_INTERPRET|DEBUG_ACTION_DUMP)
#define DEBUG_IO_PARSE				(DEBUG_MODULE_IO | DEBUG_ACTION_PARSE)
#define DEBUG_IO_LEX				(DEBUG_MODULE_IO | DEBUG_ACTION_LEX)
#define DEBUG_IO_EXE				(DEBUG_MODULE_IO | DEBUG_ACTION_EXE)
#define DEBUG_IO_DUMP				(DEBUG_MODULE_IO | DEBUG_ACTION_DUMP)
#define DEBUG_LOADER_PARSE			(DEBUG_MODULE_LOADER | DEBUG_ACTION_PARSE)
#define DEBUG_LOADER_LEX			(DEBUG_MODULE_LOADER | DEBUG_ACTION_LEX)
#define DEBUG_LOADER_EXE			(DEBUG_MODULE_LOADER | DEBUG_ACTION_EXE)
#define DEBUG_LOADER_DUMP			(DEBUG_MODULE_LOADER | DEBUG_ACTION_DUMP)
#define DEBUG_PROGRAM_PARSE			(DEBUG_MODULE_PROGRAM | DEBUG_ACTION_PARSE)
#define DEBUG_PROGRAM_LEX			(DEBUG_MODULE_PROGRAM | DEBUG_ACTION_LEX)
#define DEBUG_PROGRAM_EXE			(DEBUG_MODULE_PROGRAM | DEBUG_ACTION_EXE)
#define DEBUG_PROGRAM_DUMP			(DEBUG_MODULE_PROGRAM | DEBUG_ACTION_DUMP)
#define DEBUG_WORLD_PARSE			(DEBUG_MODULE_WORLD | DEBUG_ACTION_PARSE)
#define DEBUG_WORLD_LEX				(DEBUG_MODULE_WORLD | DEBUG_ACTION_LEX)
#define DEBUG_WORLD_EXE				(DEBUG_MODULE_WORLD | DEBUG_ACTION_EXE)
#define DEBUG_WORLD_DUMP			(DEBUG_MODULE_WORLD | DEBUG_ACTION_DUMP)

#define DEBUG_AGENT					(DEBUG_MODULE_AGENT | DEBUG_ACTION)
#define DEBUG_CONTROL				(DEBUG_MODULE_CONTROL | DEBUG_ACTION)
#define DEBUG_DICT					(DEBUG_MODULE_DICT | DEBUG_ACTION)
#define DEBUG_DUMP					(DEBUG_MODULE_DUMP | DEBUG_ACTION)
#define DEBUG_INTERPRET				(DEBUG_MODULE_INTERPRET | DEBUG_ACTION)
#define DEBUG_IO					(DEBUG_MODULE_IO | DEBUG_ACTION)
#define DEBUG_LOADER				(DEBUG_MODULE_LOADER | DEBUG_ACTION)
#define DEBUG_MISC					(DEBUG_MODULE_MISC | DEBUG_ACTION)
#define DEBUG_PROGRAM				(DEBUG_MODULE_PROGRAM | DEBUG_ACTION)
#define DEBUG_WORLD					(DEBUG_MODULE_WORLD | DEBUG_ACTION)

extern void DebugInfo ();
extern void DebugLevel ();
extern void Error ();
extern void Warning ();
extern void Print ();
extern void Message ();
extern bool Debug ();

extern int Global_WantVerboseOutput;
extern int Global_WantDebugOutput;
extern int Global_DebugLevel;

extern int Global_DebugModules;
extern int Global_DebugType;

extern int Global_IsInteractive;

#endif
