
#include "Resources.h"
#include <sys/resource.h>
#include <stdio.h>

int getpagesize (void);

struct timeval 
Res_GetUserTime ()
{
  struct rusage usage;

  getrusage (RUSAGE_SELF, &usage);
  return usage.ru_utime;
}

struct timeval 
Res_GetSystemTime ()
{
  struct rusage usage;

  getrusage (RUSAGE_SELF, &usage);
  return usage.ru_stime;
}

unsigned 
Res_GetMemoryUsage ()
{
  struct rusage usage;

  getrusage (RUSAGE_SELF, &usage);
  return usage.ru_maxrss * getpagesize ();
}

unsigned 
Res_GetVirtualMemoryUsage ()
{
  return 0;
}

struct timeval 
Res_SubtractTimes (struct timeval tv1, struct timeval tv2)
{
  struct timeval result;

  if (tv2.tv_usec > tv1.tv_usec)
    {
      result.tv_sec = tv1.tv_sec - tv2.tv_sec - 1;
      result.tv_usec = 1000000 - (tv2.tv_usec - tv1.tv_usec);
    }
  else
    {
      result.tv_sec = tv1.tv_sec - tv2.tv_sec;
      result.tv_usec = tv1.tv_usec - tv2.tv_usec;
    }

  return result;
}

char *
Res_TimevalToString (struct timeval tv, char *buffer)
{
  unsigned int hours, minutes;

  hours = tv.tv_sec / 3600;
  tv.tv_sec -= hours * 3600;

  minutes = tv.tv_sec / 60;
  tv.tv_sec -= minutes * 60;

  sprintf (buffer, "%d:%d:%ld:%ld", hours, minutes, tv.tv_sec, tv.tv_usec);

  return buffer;
}
