
#ifndef __STRINGLIST_H
#define __STRINGLIST_H

#include "TypeDefs.h"
#include "DynaString.h"

typedef struct _StringList
{
	unsigned	Allocated, Used;
	string*		Strings;
} StringListType;

StringListType*	StringList_Alloc(unsigned NumberOfStrings);
void			StringList_Destroy(StringListType* StringList, 
									bool WithContents);
void			StringList_Empty(StringListType* StringList, 
									bool WithContents);

unsigned		StringList_Count(StringListType* StringList);
string			StringList_StringAt(StringListType* StringList, int index);
int				StringList_FindString(StringListType* StringList, 
									const string String);

int				StringList_MatchString(StringListType* StringList, 
									const string String, 
									int (*comp)(const string, const string));

unsigned		StringList_AddString(StringListType* StringList, 
									string String);
void			StringList_DeleteStringAt(StringListType* StringList, 
									int index);
int				StringList_InsertStringAt(StringListType* StringList, 
									string String, int index);
string			StringList_RemoveStringAt(StringListType* StringList, 
									int index);
string			StringList_ReplaceWithString(StringListType* StringList, 
									string String, int index);


#endif