#ifndef AGENTPRGFUNC_H
#define AGENTPRGFUNC_H

/*-module-*****************************************************************
 *
 * Modul     : AgentPrgFunc (Funktionsmodul-Definitionen)
 *
 * Beschreib.: Diese Header-Datei dient zur Bereitstellung der
 *             Exportschnittstelle der gleichnamigen C-Datei.
 *             Sie muss in den Modulen includet werden, in denen
 *             die beschriebenen Ressourcen importiert werden sollen.
 *
 * Autor     : <autor>
 *
 * Datum     : <datum>
 *
 * Aender.   :
 *
 *   geaendert am              von             Bemerkungen
 *
 *--**********************************************************************/


/*-includes-*/


/*--*/


/*-defines-*/

/*--*/


/*-import-*/

extern NodePtrType AgentPrgFunc_GetFatherOfNode (NodePtrType RootNode,
						 NodePtrType Node);
extern void AgentPrgFunc_Replace (NodePtrType RootNode1, NodePtrType Node1,
				  NodePtrType Node2);


extern NodePtrType AgentPrgFunc_Create (int maxarguments);
extern void AgentPrgFunc_Insert (NodePtrType node1, NodePositionType pos,
				 NodePtrType node2);

extern void AgentPrgFunc_Set (NodePtrType node,
			      CommandType com);

extern void AgentPrgFunc_Del (NodePtrType node,
			      NodePositionType pos);
extern CountType AgentPrgFunc_Count (NodePtrType node1,
				     NodePtrType node2);

extern NodePtrType AgentPrgFunc_GetNode (NodePtrType node,
					 CountType count);

extern CountType AgentPrgFunc_NodeCount (NodePtrType node);

extern CommandType AgentPrgFunc_GetCommand (NodePtrType node);

extern NodePtrType AgentPrgFunc_GetChild (NodePtrType node,
					  NodePositionType pos);

extern NodePtrType AgentPrgFunc_CopyTree (NodePtrType node);

void freesubtree (NodeType * node);

void AgentPrgFunc_Prune (NodePtrType Node, int MaxDepth, bool withMutation);

extern NodePtrType AgentPrgFunc_Program2NodePtr (ProgramType * Program);

extern ProgramType *AgentPrgFunc_NodePtr2Program (NodePtrType NodePtr, CountType Length);
extern CountType AgentPrgFunc_GetProgramLength (ProgramType * Program);
extern void AgentPrgFunc_SetProgramLength (ProgramType * Program, CountType Length);
extern int AgnetPrgFunc_NumberOfChildren (NodeType * node);
/*--*/
#endif
