/*********************************************************
 * Zhler fr Random
 * Benutzt zwei unsigned long Variablen
 ********************************************************/

#include "DCount.h"
#include "../misc/TypeDefs.h"

inline dcount
DCount_Incr (dcount *c)
{
  if ((! ++c->low) ? (! ++c->high) : 0)
    c->isvalid = 0;
  return *c;
}

inline dcount
DCount_Decr (dcount *c)
{
  if ((! c->low--) ? (! c->high--) : 0)
    c->isvalid = 0;
  return *c;
}

inline dcount 
DCount_Set (dcount *c, unsigned long low, unsigned long high)
{
  c->low = low;
  c->high = high;
  c->isvalid = 1;
  return *c;
}

inline dcount
DCount_Reset (dcount *c)
{
  c->isvalid = 1;
  c->low = c->high = 0;
  return *c;
}

inline unsigned long
DCount_GetLow (dcount c)
{
  return c.isvalid ? c.low : 0;
}

inline unsigned long
DCount_GetHigh (dcount c)
{
  return c.isvalid ? c.high : 0;
}

inline bool
DCount_IsNull (dcount c)
{
  return c.isvalid && !c.low ? !c.high : 0;
}

inline bool
DCount_IsValid (dcount c)
{
  return c.isvalid;
}

inline dcount
DCount_Copy (dcount *to, dcount from)
{
  to->low = from.low;
  to->high = from.high;
  to->isvalid = from.isvalid;
  return *to;
}

inline dcount
DCount_SetLow (dcount *c, unsigned long low)
{
  c->low = low;
  return *c;
}

inline dcount
DCount_SetHigh (dcount *c, unsigned long high)
{
  c->high = high;
  return *c;
}


