/******************************************************
* Random.c - Wrapper fr rand55
******************************************************/
#include <math.h>

#include "../misc/Messages.h"
#include "../rand55/rand55.h"
#include "DCount.h"

#include "Random.h"

#define TRUE 1
#define FALSE 0

static dcount Random_Count;
static bool winded = FALSE;


double 
Random_DRand ()
{
  double temp;
  
  DCount_Incr (&Random_Count);
  /*  if (!DCount_IsValid (Random_Count))
    Error ("Random", "random counter overflow"); */
  temp = drand55 ();
  return temp;
}

void
Random_Reset ()
{
  DCount_Reset (&Random_Count);
}

unsigned long 
Random_LRand (long l)
{
  unsigned long temp;
  DCount_Incr (&Random_Count);
  /* if (!DCount_IsValid (Random_Count))
    Error ("Random", "random counter overflow");*/
  temp = lrand55 (l);
  return temp;
}

unsigned long 
Random_Rand ()
{
  unsigned long temp;
  
  DCount_Incr (&Random_Count);
  /*if (!DCount_IsValid (Random_Count))
    Error ("Random", "random counter overflow");*/
  temp = rand55 ();
  return temp;
}

long 
Random_Init (long seed)
{
  DCount_Reset (&Random_Count);
  return init_rand55 (seed);
}

bool 
Random_WindUp (dcount old_count)
{
  bool temp;

  temp = DCount_IsNull (Random_Count);
  DCount_Copy (&Random_Count, old_count);
  while (DCount_IsValid (DCount_Decr (&old_count)))
    rand55 ();
  winded = TRUE;
  return temp;
}

dcount
Random_Counted ()
{
  return Random_Count;
}

