


#ifndef FIELD_H
#define FIELD_H

/*-module-*****************************************************************
 *
 * Modul     : Field (Funktionsmodul-Definitionen)
 *
 * Beschreib.: Diese Header-Datei dient zur Bereitstellung der
 *             Exportschnittstelle der gleichnamigen C-Datei.
 *             Sie muss in den Modulen includet werden, in denen
 *             die beschriebenen Ressourcen importiert werden sollen.
 *             Sie stellt Hilfsfunktionen fuer World.c zur
 *             verfuegung.
 *
 * Autor     : Jens Ch. Lisner
 *
 * Datum     : 29. 1. 96
 *
 * Aender.   :
 *
 *   geaendert am              von             Bemerkungen
 *
 *--**********************************************************************/


/*-includes-*/
#include "FieldTypeDefs.h"
/* #include "Debug.h"
 */
/*--*/


/*-defines-*/

#define INITIAL_MAP_SIZE 512
/* Definiert die initiale Groesse des dynamischen Strings zur Speicherung einer Map
 */

/*--*/


/*-import-*/

/*--*/

FieldType *world;
/* Zeiger auf die Map.
   Wird von World_ParseSection gesetzt. */

int worldsize;
/* Groesse der Map linearisiert in Feldern.
   Wird von World_ParseSection gesetzt. */

int worldx, worldy;
/* Groesse der Map in X - und Y - Koordinaten.
   Wird von World_SetValueForKey gesetzt. */

float foodprop;
/* Globale Wahrscheinlichkeit dafuer dass auf einem Feld
   Futter waechst. Kann durch angaben in der Map fuer
   einzelne Felder im Worldfile ueber schrieben werden.
   Wird von World_SetValueForKey gesetzt. */

int fenergy;
/* Energiewert des neu gewachsenen Futters.
   Wird von World_SetValueForKey gesetzt. */

DynaStringType *incmap;
/* Speichert aenderungen in der Map. Wird ausgegeben falls
   Dump_WantDumpMapIncremental gesetzt. */


extern FieldType *getfield (PositionType pos);
/* Gibt Zeiger auf Feld an den Koordinaten pos aus. */

extern void completedump (int agentsonly, int foodonly);
/* Dumpt Map. 
   agentsonly == TRUE : dumpt nur Agents.
   foodonly   == TRUE : dumpt nur Food.
   Sind beide Flags == FALSE wird eine komplette Map
   ausgegeben. */

extern FieldType *createWorld ();

#endif
