
#ifndef WORLD_H
#define WORLD_H

/*-module-*****************************************************************
 *
 * Modul     : World (Funktionsmodul-Definitionen)
 *
 * Beschreib.: Diese Header-Datei dient zur Bereitstellung der
 *             Exportschnittstelle der gleichnamigen C-Datei.
 *             Sie muss in den Modulen includet werden, in denen
 *             die beschriebenen Ressourcen importiert werden sollen.
 *
 *             BEDIENUNGSANLEITUNG:
 *             Zuerst mit World_SetValueForKey alle Attributwerte
 *             setzen. Dann World_ParseSection aufrufen.
 *             Der Rest sollte klar sein.
 *
 * Autor     : Jens Ch. Lisner
 *
 * Datum     : 29. 1. 96
 *
 * Aender.   :
 *
 *   geaendert am              von             Bemerkungen
 *
 *--**********************************************************************/


/*-includes-*/

#include "../misc/TypeDefs.h"

/*-import-*/

extern inline FoodType World_GetFoodType (PositionType pos);

extern inline AgentIdType World_GetCarrionType (PositionType pos);

extern AgentIdType World_GetFoodCarrionType (PositionType pos);

extern void World_SetAgent (AgentIdType id,
			    PositionType pos);

extern AgentIdType World_AgentThere (PositionType pos);

extern inline EnergyType World_GetEnergy (PositionType pos);

extern void World_AgentMove (AgentIdType id,
			     PositionType pos_old,
			     PositionType pos_new);

extern void World_FoodRemove (PositionType pos, EnergyType amount);

extern void World_AgentFoodConvert (AgentIdType id,
				    EnergyType energie,
				    PositionType pos);

extern void World_InitTimestep (CountType timestep);

extern void World_ConcludeTimestep (CountType timestep);

extern void World_EndSimulation ();

extern bool World_ParseSection (FILE * FilePointer);
/* Diese Funktion dient auch gleichzeitig als Init,
   muss also vor allen anderen, aber nach SetValueForKey
   aufgerufen werden, da sie die Attributwerte FoodPropMap
   und WorldSize benoetigt. */

extern bool World_SetParameterValue (string AttributeName,
				     string AttributeValue);

/*--*/


#endif
